
import { world, ItemStack, system } from '@minecraft/server';
world.afterEvents.entitySpawn.subscribe(data => {
  if (data.entity.getComponent("minecraft:movement") && data.entity.getComponent("health").defaultValue > 14) {
    let entity = data.entity
    
    let random = Math.floor(1 + Math.random() * 199)
    
    
     if (random == 1) {
      
      entity.addEffect("strength", 100000, { amplifier: Math.floor(1 + Math.random() * 4), showParticles: true })
    }
    else if (random == 2) {
      entity.addTag("buff_fire")
                  entity.addEffect("resistance", 100000, { amplifier: Math.floor(1 + Math.random() * 1), showParticles: true })
    }
   else if (random == 3) {
     entity.addTag("lootnormal")
      entity.addTag("buff_tp")
    }
   else if (random == 4) {
      entity.addTag("lootruim")
            entity.addEffect("resistance", 100000, { amplifier: Math.floor(1 + Math.random() * 2), showParticles: true })
    }
   else if (random == 5) {
      entity.addTag("lootruim")
            entity.addEffect("speed", 100000, { amplifier: Math.floor(1 + Math.random() * 8), showParticles: true })
    }
    else if (random == 6) {
entity.addTag("lootnormal")
      entity.addEffect("speed", 100000, { amplifier: Math.floor(1 + Math.random() * 6), showParticles: true })
      entity.runCommandAsync("replaceitem entity @s slot.weapon.mainhand 0 minecraft:iron_sword")
      entity.runCommandAsync("replaceitem entity @s slot.armor.chest 0 minecraft:iron_chestplate")
    }
    else if (random == 7) {
      entity.addTag("lootnormal")
      entity.addEffect("speed", 100000, { amplifier: Math.floor(1 + Math.random() * 6), showParticles: true })
      entity.runCommandAsync("replaceitem entity @s slot.weapon.mainhand 0 minecraft:diamond_sword")
      entity.runCommandAsync("replaceitem entity @s slot.armor.chest 0 minecraft:diamond_chestplate")
    }
    else if (random == 8) {
      entity.addTag("lootspecial")
entity.addEffect("speed", 100000, { amplifier: Math.floor(1 + Math.random() * 6), showParticles: true })
      entity.addEffect("strength", 100000, { amplifier: Math.floor(1 + Math.random() * 4), showParticles: true })
      entity.addEffect("resistance", 100000, { amplifier: Math.floor(1 + Math.random() * 3), showParticles: true })
      entity.runCommandAsync("replaceitem entity @s slot.weapon.mainhand 0 minecraft:golden_sword")
      entity.runCommandAsync("replaceitem entity @s slot.armor.chest 0 minecraft:golden_chestplate")
      entity.runCommandAsync("replaceitem entity @s slot.armor.legs 0 minecraft:golden_leggings")
      entity.runCommandAsync("replaceitem entity @s slot.armor.head 0 minecraft:golden_helmet")
      entity.runCommandAsync("replaceitem entity @s slot.armor.feet 0 minecraft:golden_boots")
    }
    else if (random == 9) {
      entity.addTag("lootruim")
      entity.addEffect("absorption", 100000, { amplifier: Math.floor(1 + Math.random() * 3), showParticles: true })
    }
    else if (random == 10) {
      entity.addTag("lootruim")
      entity.addEffect("conduit_power", 100000, { amplifier: Math.floor(1 + Math.random() * 3), showParticles: true })
    }
    else if (random == 11) {
      entity.addTag("lootspecial")
entity.addEffect("speed", 100000, { amplifier: Math.floor(1 + Math.random() * 6), showParticles: true })
      entity.addEffect("absorption", 100000, { amplifier: Math.floor(1 + Math.random() * 4), showParticles: true })
      entity.addEffect("strength", 100000, { amplifier: Math.floor(1 + Math.random() * 4), showParticles: true })
      entity.addEffect("resistance", 100000, { amplifier: Math.floor(1 + Math.random() * 3), showParticles: true })
      
      entity.runCommandAsync("replaceitem entity @s slot.weapon.mainhand 0 minecraft:iron_sword")
      entity.runCommandAsync("replaceitem entity @s slot.armor.chest 0 minecraft:iron_chestplate")
      entity.runCommandAsync("replaceitem entity @s slot.armor.legs 0 minecraft:iron_leggings")
      entity.runCommandAsync("replaceitem entity @s slot.armor.head 0 minecraft:iron_helmet")
      entity.runCommandAsync("replaceitem entity @s slot.armor.feet 0 minecraft:iron_boots")
    }
    else if (random == 12) {
      entity.addTag("lootnormal")
      entity.addTag("buff_poison")
    }
    else if (random == 13) {
      if (entity.dimension.id == "minecraft:overworld") {
        entity.addTag("lootnormal")
        entity.addTag("buff_ice")
      } 
    }
    
      
    
    else if (random == 14) {
      entity.addTag("buff_spider")
    }
        else if (random == 15) {
entity.addTag("lootruim")
          entity.addEffect("invisibility", 100000, { amplifier: Math.floor(1 + Math.random() * 3), showParticles: true })
    }
              
            else if (random == 16) {
              entity.addTag("lootnormal")
              entity.addTag("buff_wither")
    }
                else if (random == 17) {
                  entity.addTag("lootnormal")
              entity.addTag("buff_weakness")
    }
                    else if (random == 18) {
                      entity.addTag("lootnormal")
              entity.addTag("buff_darkness")
    }
                        else if (random == 19) {
entity.addTag("lootruim")
                          entity.addEffect("health_boost", 100000, { amplifier: Math.floor(1 + Math.random() * 4), showParticles: true })
    }
                         else if (random == 20) {
entity.addTag("lootruim")
                          entity.addEffect("regeneration", 100000, { amplifier: Math.floor(1 + Math.random() * 4), showParticles: true })
    }
  
  }
})
world.afterEvents.entityHitEntity.subscribe(data => {
  let ent = data.damagingEntity
  if (data.hitEntity.hasTag("buff_tp") == true) {
    data.hitEntity.runCommandAsync(`tp @s ^^^6`)
  }
  if (ent.hasTag("buff_fire")) {
    data.hitEntity.runCommandAsync(`setblock ~~~ fire`)
    
  }
  if (ent.hasTag("buff_poison")) {
    data.hitEntity.runCommandAsync(`effect @s poison 10 2`)
    
  }
if (ent.hasTag("buff_ice")) {
    data.hitEntity.runCommandAsync(`effect @s slowness 10 4`)
    
  }
  if (data.hitEntity.hasTag("buff_spider")) {
    if (1 + Math.floor(1 + Math.random() * 3) == 2) {
      ent.runCommandAsync(`setblock ~~~ web`)
    }
   
  }
  if (ent.hasTag("buff_wither")) {
    data.hitEntity.runCommandAsync(`effect @s wither 10 3`)
    
  } 
  if (ent.hasTag("buff_weakness")) {
    data.hitEntity.runCommandAsync(`effect @s weakness 10 3`)
    
  } 
  if (data.hitEntity.hasTag("buff_darkness")) {
    ent.runCommandAsync(`effect @s darkness 10 3`)
    
  }  
  if (data.hitEntity.getComponent("health").currentValue < 1) {
    if (data.hitEntity.hasTag("lootruim")) {
      data.hitEntity.runCommandAsync(`loot spawn ~~~ loot "cu/lootruim"`)
      data.hitEntity.kill()
    }
        if (data.hitEntity.hasTag("lootnormal")) {
      data.hitEntity.runCommandAsync(`loot spawn ~~~ loot "cu/lootnormal"`)
      data.hitEntity.kill()
    }
        if (data.hitEntity.hasTag("lootspecial")) {
      data.hitEntity.runCommandAsync(`loot spawn ~~~ loot "cu/lootspecial"`)
      data.hitEntity.kill()
    }
  }
})
